package com.ghomerr.linkedchest.utils;

import com.ghomerr.linkedchest.enums.Configurations;

public class DebugUtils
{
	public static boolean isDebugEnabled()
	{
		final Boolean bool = ConfigurationUtils.getConfigValueByType(Configurations.DEBUG, Boolean.class);
		if (bool != null)
		{
			return bool.booleanValue();
		}
		else
		{
			return false;
		}
	}

	public static boolean toggleDebug()
	{
		Boolean debugState = new Boolean(!isDebugEnabled());
		debugState = ConfigurationUtils.setConfigValue(Configurations.DEBUG, debugState);

		return debugState.booleanValue();
	}

	public static void setDebugEnabled(final boolean state)
	{
		final Boolean bool = new Boolean(state);
		ConfigurationUtils.setConfigValue(Configurations.DEBUG, bool);
	}
}
